---
layout: news_item
date: "2023-02-07 12:00:00 +0000"
author: jbalint
version: 1.33.0
categories: [release]
tag: v1-33-0
sha: 5ad825c
---
<!--
{% comment %}
Licensed to the Apache Software Foundation (ASF) under one or more
contributor license agreements.  See the NOTICE file distributed with
this work for additional information regarding copyright ownership.
The ASF licenses this file to you under the Apache License, Version 2.0
(the "License"); you may not use this file except in compliance with
the License.  You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
{% endcomment %}
-->

The [Apache Calcite PMC]({{ site.baseurl }})
is pleased to announce
[Apache Calcite release 1.33.0]({{ site.baseurl }}/docs/history.html#v1-33-0).

This release comes five months after [1.32.0](#v1-32-0),
contains contributions from 33 contributors, and resolves 107 issues.

Among others, it is worth highlighting the following improvements:


* Many improvements to the BigQuery dialect as part of [<a href="https://issues.apache.org/jira/browse/CALCITE-5180">CALCITE-5180</a>]
  * [<a href="https://issues.apache.org/jira/browse/CALCITE-5269">CALCITE-5269</a>]
    Implement BigQuery `TIME_TRUNC` and `TIMESTAMP_TRUNC` functions
  * [<a href="https://issues.apache.org/jira/browse/CALCITE-5360">CALCITE-5360</a>]
    Implement `TIMESTAMP_ADD` function (compatible with BigQuery)
  * [<a href="https://issues.apache.org/jira/browse/CALCITE-5389">CALCITE-5389</a>]
    Add `STARTS_WITH` and `ENDS_WITH` functions (for `BIG_QUERY` compatibility)
  * [<a href="https://issues.apache.org/jira/browse/CALCITE-5404">CALCITE-5404</a>]
    Implement BigQuery's `POW()` and `TRUNC()` math functions
  * [<a href="https://issues.apache.org/jira/browse/CALCITE-5423">CALCITE-5423</a>]
    Implement `TIMESTAMP_DIFF` function (compatible with BigQuery)
  * [<a href="https://issues.apache.org/jira/browse/CALCITE-5430">CALCITE-5430</a>]
    Implement `IFNULL()` for BigQuery dialect
  * [<a href="https://issues.apache.org/jira/browse/CALCITE-5432">CALCITE-5432</a>]
    Implement BigQuery `TIME_ADD`/`TIME_DIFF`
  * [<a href="https://issues.apache.org/jira/browse/CALCITE-5436">CALCITE-5436</a>]
    Implement `DATE_SUB`, `TIME_SUB`, `TIMESTAMP_SUB` (compatible w/ BigQuery)
  * [<a href="https://issues.apache.org/jira/browse/CALCITE-5447">CALCITE-5447</a>]
    Add `DATE_TRUNC` for BigQuery
* [<a href="https://issues.apache.org/jira/browse/CALCITE-5105">CALCITE-5105</a>]
  Add `MEASURE` type and `AGGREGATE` aggregate function
* [<a href="https://issues.apache.org/jira/browse/CALCITE-5155">CALCITE-5155</a>]
  Custom time frames
* [<a href="https://issues.apache.org/jira/browse/CALCITE-5280">CALCITE-5280</a>]
  Implement geometry aggregate functions
* [<a href="https://issues.apache.org/jira/browse/CALCITE-5314">CALCITE-5314</a>]
  Prune empty parts of a query by exploiting stats/metadata
